package UnitTests;

import static org.junit.Assert.*;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.ArrayList;

import org.junit.Test;

import rmi.Client;
import rmi.ClientInterface;
import rmi.Server;
import rmi.ServerInteface;
import rmi.Users;

/**
 * This class test the method toggleFollowUser in the Server. We are testing
 * when calling the method toggleFollowUser in the Server class the method
 * should make the user follow or unfollow an other user
 * 
 */
public class Following {

	String srcUser = "ina";
	String destUser = "w.rooney";

	@Test
	public void test() {
		try {
			ServerInteface server = new Server();
			server.connectToServer();
			Registry registry = LocateRegistry.createRegistry(5010);
			registry.rebind("Server", server);

			ClientInterface srcClient = new Client();
			srcClient.setUsername(srcUser);

			ClientInterface destClient = new Client();
			destClient.setUsername(destUser);

			// Get the size of the followings before calling the method
			// toggleFollowUser
			int oldSize = server.getFollowing(srcClient).size();
			System.out.println(oldSize);
			server.toggleFollowUser(srcClient, destClient.getUsername());

			/*
			 * Get the size of the followings after calling the method
			 * toggleFollowUser which will increase by one if srcClient was not
			 * following the destClient before calling the method otherwise it
			 * will decrease by one
			 */
			int newSize = server.getFollowing(srcClient).size();
			System.out.println(newSize);

			/*
			 * check if the srcClient is following the destClient after calling
			 * the method. If yes then the oldSize will be newSize -1, otherwise
			 * it will be newSize+1
			 */
			boolean isFollowing = false;
			for (Users following : server.getFollowing(srcClient)) {
				if (following.getUsername().equals(destClient.getUsername())) {
					isFollowing = true;
				}
			}

				if (isFollowing){
					int os = oldSize +1;
					assertTrue(os == newSize);
				}

				else{
					int os = oldSize -1;
					assertTrue(os == newSize);
				}
			

		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}