package UnitTests;

import static org.junit.Assert.*;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import org.junit.Test;

import rmi.Client;
import rmi.ClientInterface;
import rmi.Server;
import rmi.ServerInteface;

/**
 * This class tests the method tweet and getMytweets in the Server Class.
 * We test when calling the method tweet from the server the size of myTweet should increase by one.
 *
 */
public class MyTweet {
	
	String srcUser = "ina";
	

	@Test
	public void test() {
		try {
			ServerInteface server = new Server();
			server.connectToServer();
			Registry registry = LocateRegistry.createRegistry(5010);
			registry.rebind("Server", server);
			
			ClientInterface srcClient = new Client();
			srcClient.setUsername(srcUser);
			
			
		
			//get the size of myTweets before calling the method tweet
			double oldSizeMyTweet = server.getMyTweets(srcClient.getUsername()).size();
			
			server.tweet(srcClient, "Hello");
			
			//get the size of myTweets after calling the method tweet which should be increased by one
			double newSizeMytweet = server.getMyTweets(srcClient.getUsername()).size();
			
			assertTrue(oldSizeMyTweet+1==newSizeMytweet);
			
			
			
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
