package UnitTests;

import static org.junit.Assert.*;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import org.junit.Test;

import rmi.Client;
import rmi.ClientInterface;
import rmi.Server;
import rmi.ServerInteface;

/**
 *This class tests the method sendPrivateMessage in Server.
 *We check if the size of the getPrivateMessage has increased for the destUser after calling the method
 *sendPrivateMessage from the srcUser  
 *
 */
public class PrivateMessage {

	String srcUser="ina",destUser="w.rooney";
	
	@Test
	public void test() {
		
		try {
			ServerInteface server = new Server();
			server.connectToServer();
			Registry registry = LocateRegistry.createRegistry(5010);
			registry.rebind("Server", server);
			
			ClientInterface srcClient = new Client();
			srcClient.setUsername(srcUser);
			
			ClientInterface destClient = new Client();
			destClient.setUsername(destUser);
			
			String message = "Hello";
			
			//get the size of getPrivateMessage of the destClient before calling the method sendPrivateMessage
			double oldSize = server.getPrivateMessages(destClient).size();
			server.sendPrivateMessage(srcClient, destClient.getUsername(), message);

			/*/get the size of getPrivateMessage of the destClient after calling the method sendPrivateMessage
			which should be increased by one*/
			double newSize = server.getPrivateMessages(destClient).size();
			
			assertTrue(oldSize+1==newSize);
			
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		

	}

}
