package UnitTests;

import static org.junit.Assert.*;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.ArrayList;

import org.junit.Test;

import rmi.Client;
import rmi.ClientInterface;
import rmi.Server;
import rmi.ServerInteface;
import rmi.Users;

/**
 * This class tests the method tweet and getTweets in the Server Class. We test
 * when calling the method tweet from the server the size of getTweets should
 * increase by one for the user that is following the user that tweeted.
 * 
 * @author myriana
 * 
 */
public class Tweet {

	String srcUser = "ina";
	String destUser = "w.rooney";

	@Test
	public void test() {
		try {
			ServerInteface server = new Server();
			server.connectToServer();
			Registry registry = LocateRegistry.createRegistry(5010);
			registry.rebind("Server", server);

			ClientInterface srcClient = new Client();
			srcClient.setUsername(srcUser);

			ClientInterface destClient = new Client();
			destClient.setUsername(destUser);

			ArrayList<Users> followings = server.getFollowing(destClient);

			// get the size of getTweets for the srcUser before calling the
			// method tweet
			double oldSizeTweet = server.getTweets(destClient).size();

			boolean isFollowing = false;
			/*
			 * Checks if the destUser in following srcUser. If yes do nothing
			 * otherwise follow the srcUser
			 */
			for (Users following : followings) {
				if (following.getUsername().equals(srcClient.getUsername()) ) {
					isFollowing = true;
				}
			}
			if (!isFollowing)
				server.toggleFollowUser(destClient,srcClient.getUsername());

			server.tweet(srcClient, "Hello");
			
			// get the size of getTweets for the destUser after calling the
			// method tweet which should be increased by one
			double newSizeTweet = server.getTweets(destClient).size();

			assertTrue(oldSizeTweet + 1 == newSizeTweet);

		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
