package graphical;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import rmi.Client;
import rmi.Tweets;
import rmi.Users;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Panel;
import java.awt.TextArea;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BoxLayout;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.factories.FormFactory;
import net.miginfocom.swing.MigLayout;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.UIManager;

public class MainFrame extends JFrame implements SearchEventListener,
		MainPanelEventListener {
	Client client;
	MainPanel mainPanel;
	JPanel leftPanel, tweetPanel;
	static SearchPanel searchPanel;
	JLabel lblTweet, lblFollowing, lblFollowers;
	JTextField tweetText;
	static int newPrivateMessageCounter=0,newTweetsCounter=0;
	

	/**
	 * Create the frame.
	 * 
	 * @param client
	 * @throws RemoteException
	 */
	public MainFrame(final Client client) throws RemoteException {

		this.client = client;
		
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				client.logout();
				MainFrame.this.remove(mainPanel);
				System.exit(0);
			}
		});
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 824, 530);
		getContentPane().setLayout(new BorderLayout(0, 0));


		 searchPanel = new SearchPanel();
		getContentPane().add(searchPanel, BorderLayout.NORTH);
		searchPanel.addEventListener(this);

		mainPanel = new MainPanel(client.getTweets(), Tweets.class);
		mainPanel.addEventListener(this);
		getContentPane().add(mainPanel, BorderLayout.CENTER);

		buildLeftPanel();
		buildTweetPanel();

	}

	private void buildTweetPanel() {
		
		tweetPanel = new JPanel();
		mainPanel.add(tweetPanel, BorderLayout.SOUTH);
		tweetPanel.setLayout(new FormLayout(
				new ColumnSpec[] { FormFactory.RELATED_GAP_COLSPEC,
						ColumnSpec.decode("default:grow"),
						FormFactory.RELATED_GAP_COLSPEC,
						FormFactory.DEFAULT_COLSPEC, }, new RowSpec[] {
						FormFactory.RELATED_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC, }));

		tweetText = new JTextField();
		tweetText.setFont(new Font("Calibri", Font.PLAIN, 14));
		tweetText.setColumns(10);
		tweetPanel.add(tweetText, "2, 1, 1, 2, fill, default");

		JButton button = new JButton("Enter Tweet!!");

		button.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				String text = tweetText.getText();
				if(text.isEmpty()){
					JOptionPane.showMessageDialog(MainFrame.this, "Enter the text of a tweet.");return;
				}
				System.out.println(text);
				try {
					client.tweet(text);
					ArrayList<Tweets> tweets = client.getTweets();
					
					MainFrame.this.remove(mainPanel);

					mainPanel = new MainPanel(tweets, Tweets.class);
					mainPanel.setVisible(true);
					mainPanel.addEventListener(MainFrame.this);
					getContentPane().add(mainPanel, BorderLayout.CENTER);
					buildTweetPanel();
					buildLeftPanel();
					MainFrame.this.repaint();
					MainFrame.this.validate();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		});
		button.setFont(new Font("Calibri", Font.PLAIN, 15));		
		tweetPanel.add(button, "4, 2, fill, default");
		

	}

	private void buildLeftPanel() {
		leftPanel = new JPanel();
		mainPanel.add(leftPanel, BorderLayout.WEST);

		leftPanel.setLayout(new FormLayout(
				new ColumnSpec[] { FormFactory.RELATED_GAP_COLSPEC,
						FormFactory.DEFAULT_COLSPEC, }, new RowSpec[] {
						FormFactory.RELATED_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.RELATED_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.RELATED_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.RELATED_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,}));
		
		JButton button = new JButton("Log Out");
		button.setFont(new Font("Calibri", Font.PLAIN, 18));
		leftPanel.add(button, "2,8");
		button.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				client.logout();
				MainFrame.this.remove(mainPanel);
				System.exit(0);
				
			}
		});
//**
		try {
			if(client.getMyTweets(client.getUsername())!= null){
			try {
				
				lblTweet = new JLabel("Tweet ("
						+ client.getMyTweets(client.getUsername()).size() + ")");
				
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			lblTweet.setForeground(new Color(0, 139, 139));
			lblTweet.setFont(new Font("Calibri", Font.PLAIN, 18));
			lblTweet.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			lblTweet.setAlignmentX(0.5f);
			lblTweet.addMouseListener(new MouseListener() {

				@Override
				public void mouseReleased(MouseEvent arg0) {

				}

				@Override
				public void mousePressed(MouseEvent arg0) {
					btnHomePressed();

				}

				@Override
				public void mouseExited(MouseEvent arg0) {
					getRootPane().setCursor(
							Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
				}

				@Override
				public void mouseEntered(MouseEvent arg0) {
					getRootPane().setCursor(
							Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

				}

				@Override
				public void mouseClicked(MouseEvent arg0) {

				}
			});
			leftPanel.add(lblTweet, "2, 2");
			}
		} catch (RemoteException e3) {
			// TODO Auto-generated catch block
			e3.printStackTrace();
		}
		try {
			lblFollowing = new JLabel("Following (" + client.getFollowing().size() + ")");
		} catch (RemoteException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		lblFollowing.setForeground(new Color(0, 139, 139));
		lblFollowing.setFont(new Font("Calibri", Font.PLAIN, 18));
		lblFollowing.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		lblFollowing.setAlignmentX(0.5f);
		lblFollowing.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent arg0) {

			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				ArrayList<Users> tweets=null;
				try {
					tweets = client.getFollowing();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				MainFrame.this.remove(mainPanel);

				mainPanel = new MainPanel(tweets, Users.class);
				mainPanel.setVisible(true);
				mainPanel.addEventListener(MainFrame.this);
				getContentPane().add(mainPanel, BorderLayout.CENTER);
				buildTweetPanel();
				buildLeftPanel();
				MainFrame.this.repaint();
				MainFrame.this.validate();

			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

			}

			@Override
			public void mouseClicked(MouseEvent arg0) {

			}
		});
		leftPanel.add(lblFollowing, "2, 4");

		try {
			lblFollowers = new JLabel("Followers (" + client.getFollowers().size() + ")");
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		lblFollowers.setForeground(new Color(0, 139, 139));
		lblFollowers.setFont(new Font("Calibri", Font.PLAIN, 18));
		lblFollowers.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		lblFollowers.setAlignmentX(0.5f);
		lblFollowers.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent arg0) {

			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				ArrayList<Users> tweets=null;
				try {
					tweets = client.getFollowers();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				MainFrame.this.remove(mainPanel);

				mainPanel = new MainPanel(tweets, Users.class);
				mainPanel.setVisible(true);
				mainPanel.addEventListener(MainFrame.this);
				getContentPane().add(mainPanel, BorderLayout.CENTER);
				buildTweetPanel();
				buildLeftPanel();
				MainFrame.this.repaint();
				MainFrame.this.validate();

			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

			}

			@Override
			public void mouseClicked(MouseEvent arg0) {

			}
		});
		leftPanel.add(lblFollowers, "2,6");


	}

	@Override
	public void btnSearchUsersPressed(String text) {
		ArrayList<Users> users = client.searchForUsers(text);
		this.remove(mainPanel);

		mainPanel = new MainPanel(users, Users.class);
		mainPanel.setVisible(true);
		mainPanel.addEventListener(this);
		getContentPane().add(mainPanel, BorderLayout.CENTER);
		buildTweetPanel();
		buildLeftPanel();
		this.repaint();
		this.validate();

	}

	@Override
	public void btnSearchTagsPressed(String text) {
		ArrayList<Tweets> tweets = client.searchForTags(text);

		this.remove(mainPanel);

		mainPanel = new MainPanel(tweets, Tweets.class);
		mainPanel.setVisible(true);
		mainPanel.addEventListener(this);
		getContentPane().add(mainPanel, BorderLayout.CENTER);
		buildTweetPanel();
		buildLeftPanel();
		this.repaint();
		this.validate();
	}

	@Override
	public void btnMyTweetsPressed() {
		try {
			ArrayList<Tweets> tweets = client.getMyTweets(client
					.getUsername());

			this.remove(mainPanel);

			mainPanel = new MainPanel(tweets, Tweets.class);
			mainPanel.setVisible(true);
			mainPanel.addEventListener(this);
			getContentPane().add(mainPanel, BorderLayout.CENTER);
			buildTweetPanel();
			buildLeftPanel();
			this.repaint();
			this.validate();
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void btnHomePressed() {
		try {
			newTweetsCounter=0;
			ArrayList<Tweets> tweets = client.getTweets();

			this.remove(mainPanel);

			mainPanel = new MainPanel(tweets, Tweets.class);
			mainPanel.setVisible(true);
			mainPanel.addEventListener(this);
			getContentPane().add(mainPanel, BorderLayout.CENTER);
			buildTweetPanel();
			buildLeftPanel();
			this.repaint();
			this.validate();

		} catch (RemoteException e) {
			e.printStackTrace();
		}

	}

	@Override
	public void btnPrivateMessagePressed() {
		newPrivateMessageCounter=0;
		ArrayList<Tweets> tweets = client.getPrivateMessages();

		this.remove(mainPanel);

		mainPanel = new MainPanel(tweets, Tweets.class);
		mainPanel.setVisible(true);
		mainPanel.addEventListener(this);
		getContentPane().add(mainPanel, BorderLayout.CENTER);
		buildTweetPanel();
		buildLeftPanel();
		this.repaint();
		this.validate();

	}

	@Override
	public void btnFollowPressed(String user) {
		client.toggleFollowUser(user);
		buildLeftPanel();

	}

	@Override
	public void userDoubleClicked(String user) {

		ArrayList<Tweets> tweets = client.getMyTweets(user);

		this.remove(mainPanel);

		mainPanel = new MainPanel(tweets, Tweets.class);
		mainPanel.setVisible(true);
		mainPanel.addEventListener(this);
		getContentPane().add(mainPanel, BorderLayout.CENTER);
		buildTweetPanel();
		buildLeftPanel();
		this.repaint();
		this.validate();
	}

	@Override
	public void btnRetweetClicked(Integer messageID) {
		try {
			System.out.println(messageID);
			client.reTweet(messageID);
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	
	@Override
	public void btnPrivateMessageClicked(String userName) {
		String message = JOptionPane.showInputDialog("Send your private message.");
		client.sendPrivateMessage(userName, message);
		
	}


	public static void recieveNewTweet(){
		newTweetsCounter++;
		searchPanel.notifyHomeLabel(newTweetsCounter);
	}
	public static void recieveNewPrivateMessage(){
		newPrivateMessageCounter++;
		searchPanel.notifyPrivateLabel(newPrivateMessageCounter);
	}
	
}
