package graphical;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JLabel;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.factories.FormFactory;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Font;
import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import java.awt.FlowLayout;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.event.EventListenerList;

import java.awt.Component;

public class SearchPanel extends JPanel {

	/**
	 * Create the panel.
	 */

	ArrayList<SearchEventListener> listeners;
	final JLabel lblHome,lblPrivateMessages;
	private JTextField tdSearchText;

	public void addEventListener(SearchEventListener listener) {
		listeners.add(listener);
	}

	public void removeEventListener(SearchEventListener listener) {
		listeners.remove(listener);
	}

	public SearchPanel() {

		listeners = new ArrayList<SearchEventListener>();

		 lblHome = new JLabel("HOME");
		lblHome.setAlignmentX(Component.CENTER_ALIGNMENT);
		lblHome.setForeground(Color.DARK_GRAY);
		lblHome.setFont(new Font("Calibri", Font.PLAIN, 18));
		lblHome.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		lblHome.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent arg0) {

			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				clearHomeLabelNotification();
				for (SearchEventListener listener : listeners)
					listener.btnHomePressed();

			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

			}

			@Override
			public void mouseClicked(MouseEvent arg0) {

			}
		});

		JLabel lblMyTweets = new JLabel("MY Tweets");
		lblMyTweets.setForeground(Color.DARK_GRAY);
		lblMyTweets.setFont(new Font("Calibri", Font.PLAIN, 18));
		lblMyTweets.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		lblMyTweets.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent arg0) {

			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				for (SearchEventListener listener : listeners)
					listener.btnMyTweetsPressed();
			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

			}

			@Override
			public void mouseClicked(MouseEvent arg0) {

			}
		});

		tdSearchText = new JTextField();
		tdSearchText.setFont(new Font("Calibri", Font.PLAIN, 14));
		tdSearchText.setColumns(10);

		JButton btnSearchUsers = new JButton("Search Users");
		btnSearchUsers.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				for (SearchEventListener listener : listeners)
					listener.btnSearchUsersPressed(tdSearchText.getText());

			}
		});
		btnSearchUsers.setFont(new Font("Calibri", Font.PLAIN, 15));

		JButton btnSearchTags = new JButton("Search Tags");
		btnSearchTags.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				for (SearchEventListener listener : listeners)
					listener.btnSearchTagsPressed(tdSearchText.getText());
			}
		});
		btnSearchTags.setFont(new Font("Calibri", Font.PLAIN, 15));

		lblPrivateMessages = new JLabel("Private Messages");
		lblPrivateMessages.setForeground(Color.DARK_GRAY);
		lblPrivateMessages.setFont(new Font("Calibri", Font.PLAIN, 18));
		lblPrivateMessages.setBorder(BorderFactory
				.createLineBorder(Color.BLACK));
		lblPrivateMessages.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent arg0) {

			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				clearPrivateLabelNotification();
				for (SearchEventListener listener : listeners)
					listener.btnPrivateMessagePressed();
			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				getRootPane().setCursor(
						Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

			}

			@Override
			public void mouseClicked(MouseEvent arg0) {

			}
		});

		GroupLayout groupLayout = new GroupLayout(this);
		groupLayout.setHorizontalGroup(groupLayout.createParallelGroup(
				Alignment.LEADING).addGroup(
				groupLayout
						.createSequentialGroup()
						.addComponent(lblHome, GroupLayout.DEFAULT_SIZE, 49,
								Short.MAX_VALUE)
						.addGap(5)
						.addComponent(lblMyTweets, GroupLayout.DEFAULT_SIZE,
								84, Short.MAX_VALUE)
						.addPreferredGap(ComponentPlacement.RELATED)
						.addComponent(lblPrivateMessages,
								GroupLayout.DEFAULT_SIZE, 128, Short.MAX_VALUE)
						.addPreferredGap(ComponentPlacement.RELATED)
						.addComponent(tdSearchText, GroupLayout.DEFAULT_SIZE,
								79, Short.MAX_VALUE)
						.addPreferredGap(ComponentPlacement.RELATED)
						.addComponent(btnSearchUsers, GroupLayout.DEFAULT_SIZE,
								111, Short.MAX_VALUE)
						.addPreferredGap(ComponentPlacement.RELATED)
						.addComponent(btnSearchTags, GroupLayout.DEFAULT_SIZE,
								111, Short.MAX_VALUE).addContainerGap()));
		groupLayout
				.setVerticalGroup(groupLayout
						.createParallelGroup(Alignment.LEADING)
						.addGroup(
								groupLayout
										.createSequentialGroup()
										.addGroup(
												groupLayout
														.createParallelGroup(
																Alignment.LEADING)
														.addGroup(
																groupLayout
																		.createSequentialGroup()
																		.addGap(1)
																		.addComponent(
																				lblHome,
																				GroupLayout.PREFERRED_SIZE,
																				25,
																				GroupLayout.PREFERRED_SIZE))
														.addGroup(
																groupLayout
																		.createParallelGroup(
																				Alignment.BASELINE)
																		.addComponent(
																				btnSearchTags,
																				GroupLayout.PREFERRED_SIZE,
																				27,
																				GroupLayout.PREFERRED_SIZE)
																		.addComponent(
																				btnSearchUsers,
																				GroupLayout.PREFERRED_SIZE,
																				27,
																				GroupLayout.PREFERRED_SIZE)
																		.addComponent(
																				tdSearchText,
																				GroupLayout.PREFERRED_SIZE,
																				23,
																				GroupLayout.PREFERRED_SIZE))
														.addGroup(
																groupLayout
																		.createSequentialGroup()
																		.addGap(1)
																		.addGroup(
																				groupLayout
																						.createParallelGroup(
																								Alignment.BASELINE)
																						.addComponent(
																								lblMyTweets,
																								GroupLayout.PREFERRED_SIZE,
																								25,
																								GroupLayout.PREFERRED_SIZE)
																						.addComponent(
																								lblPrivateMessages,
																								GroupLayout.PREFERRED_SIZE,
																								25,
																								GroupLayout.PREFERRED_SIZE))))
										.addContainerGap(
												GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)));
		setLayout(groupLayout);

	}

	public void clearHomeLabelNotification() {

		lblHome.setText("Home");
		lblHome.setForeground(Color.DARK_GRAY);
		lblHome.setFont(new Font("Calibri", Font.PLAIN, 18));
	}

	public void notifyHomeLabel(int counter) {

		lblHome.setText("Home("+counter+")");
		lblHome.setForeground(Color.RED);
		lblHome.setFont(new Font("Calibri", Font.PLAIN, 18));
	}
	public void clearPrivateLabelNotification() {

		lblPrivateMessages.setText("Private Messages");
		lblPrivateMessages.setForeground(Color.DARK_GRAY);
		lblPrivateMessages.setFont(new Font("Calibri", Font.PLAIN, 18));
	}

	public void notifyPrivateLabel(int counter) {

		lblPrivateMessages.setText("Private Messages("+counter+")");
		lblPrivateMessages.setForeground(Color.RED);
		lblPrivateMessages.setFont(new Font("Calibri", Font.PLAIN, 18));
	}
}