package rmi;
import java.rmi.RemoteException;

import javax.swing.JFrame;

import graphical.LogInEventListener;
import graphical.LoginFrame;
import graphical.MainFrame;
import graphical.TweetPanel;

public class Launcher implements LogInEventListener {

	Client client;
	LoginFrame loginFrame;
	MainFrame mainFrame;
	public Launcher() {
		try {
			client = new Client();

			loginFrame = new LoginFrame();
			loginFrame.addEventListener(this);
			loginFrame.setVisible(true);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		Launcher l = new Launcher();
	}

	@Override
	public boolean btnSignInPressed(String username, String password) {

		try {
			if (client.login(username, password)){
				loginFrame.dispose();
				
				mainFrame=new MainFrame(client);
				mainFrame.setVisible(true);
				return true;
			}
			return false;
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return false;

	}

	@Override
	public boolean btnSignUpPressed(String username, String firstName,
			String lastName, String email, String password) {
		try {
			if (client.signup(username, firstName, lastName, password, email)){
				loginFrame.dispose();
				
				mainFrame=new MainFrame(client);
				mainFrame.setVisible(true);
				return true;
			}
			return false;
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return false;
	}
}
